{
    "$graph": [
        {
            "class": "CommandLineTool",
            "arguments": [
                "$(inputs.bcftools)",
                "concat"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 8000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                },
                {
                    "types": [
                        {
                            "type": "record",
                            "name": "#variants_tools.yaml/run_tools",
                            "fields": [
                                {
                                    "name": "#variants_tools.yaml/run_tools/bcftools",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/gbcms",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/java_7",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/mutect",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vardict",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vardict_testsomatic",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vardict_var2vcf_paired",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/perl",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vcf2maf",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vep_path",
                                    "type": "string"
                                },
                                {
                                    "name": "#variants_tools.yaml/run_tools/vep_data",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#bcftools.yaml/bcftools_params",
                            "type": "record",
                            "fields": [
                                {
                                    "type": "boolean",
                                    "name": "#bcftools.yaml/bcftools_params/allow_overlaps"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/compact_PS"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/ligate"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/list"
                                },
                                {
                                    "type": [
                                        "null",
                                        "int"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/min_PQ"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/naive"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/no_version"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/output"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/output_type"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/regions"
                                },
                                {
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/regions_file"
                                },
                                {
                                    "type": [
                                        "null",
                                        "boolean"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/remove_duplicates"
                                },
                                {
                                    "type": "string",
                                    "name": "#bcftools.yaml/bcftools_params/rm_dups"
                                },
                                {
                                    "type": [
                                        "null",
                                        "int"
                                    ],
                                    "name": "#bcftools.yaml/bcftools_params/threads"
                                }
                            ]
                        }
                    ],
                    "class": "SchemaDefRequirement"
                }
            ],
            "doc": "concatenate VCF/BCF files from the same set of samples\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "First coordinate of the next file can precede last record of the current file.",
                    "inputBinding": {
                        "prefix": "--allow-overlaps"
                    },
                    "id": "#bcftools_concat.cwl/allow_overlaps"
                },
                {
                    "type": "string",
                    "id": "#bcftools_concat.cwl/bcftools"
                },
                {
                    "type": "#bcftools.yaml/bcftools_params",
                    "id": "#bcftools_concat.cwl/bcftools_params"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Do not output PS tag at each site, only at the start of a new phase set block.",
                    "inputBinding": {
                        "prefix": "--compact-PS"
                    },
                    "id": "#bcftools_concat.cwl/compact_PS"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ligate phased VCFs by matching phase at overlapping haplotypes",
                    "inputBinding": {
                        "prefix": "--ligate"
                    },
                    "id": "#bcftools_concat.cwl/ligate"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Read the list of files from a file.",
                    "inputBinding": {
                        "prefix": "--file-list"
                    },
                    "id": "#bcftools_concat.cwl/list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Break phase set if phasing quality is lower than <int> [30]",
                    "inputBinding": {
                        "prefix": "--min-PQ"
                    },
                    "id": "#bcftools_concat.cwl/min_PQ"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Concatenate BCF files without recompression (dangerous, use with caution)",
                    "inputBinding": {
                        "prefix": "--naive"
                    },
                    "id": "#bcftools_concat.cwl/naive"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "do not append version and command line to the header",
                    "inputBinding": {
                        "prefix": "--no-version"
                    },
                    "id": "#bcftools_concat.cwl/no_version"
                },
                {
                    "type": "string",
                    "id": "#bcftools_concat.cwl/normal_sample_name"
                },
                {
                    "type": "string",
                    "doc": "Write output to a file [standard output]",
                    "default": "bcftools_concat.vcf",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#bcftools_concat.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "<b|u|z|v> b - compressed BCF, u - uncompressed BCF, z - compressed VCF, v - uncompressed VCF [v]",
                    "inputBinding": {
                        "prefix": "--output-type"
                    },
                    "id": "#bcftools_concat.cwl/output_type"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Restrict to comma-separated list of regions",
                    "inputBinding": {
                        "prefix": "--regions"
                    },
                    "id": "#bcftools_concat.cwl/regions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Restrict to regions listed in a file",
                    "inputBinding": {
                        "prefix": "--regions-file"
                    },
                    "id": "#bcftools_concat.cwl/regions_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Alias for -d none",
                    "inputBinding": {
                        "prefix": "--remove-duplicates"
                    },
                    "id": "#bcftools_concat.cwl/remove_duplicates"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Output duplicate records present in multiple files only once - <snps|indels|both|all|none>",
                    "inputBinding": {
                        "prefix": "--rm-dups"
                    },
                    "id": "#bcftools_concat.cwl/rm_dups"
                },
                {
                    "type": "#variants_tools.yaml/run_tools",
                    "id": "#bcftools_concat.cwl/run_tools"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of extra output compression threads [0]",
                    "inputBinding": {
                        "prefix": "--threads"
                    },
                    "id": "#bcftools_concat.cwl/threads"
                },
                {
                    "type": "string",
                    "id": "#bcftools_concat.cwl/tumor_sample_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "Array of vcf files to be concatenated into one vcf",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#bcftools_concat.cwl/vcf_files"
                }
            ],
            "id": "#bcftools_concat.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${return inputs.output;}"
                    },
                    "id": "#bcftools_concat.cwl/concat_vcf_output_file"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "annotate_concat",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "ramMin": 4000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "doc": "Annotates common variants in concatenated vcf and another vcf with tag from inputted header file\n",
            "inputs": [
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "doc": "Input txt header file",
                    "inputBinding": {
                        "prefix": "--anno_header"
                    },
                    "id": "#annotate_concat.cwl/anno_header"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "doc": "Input vcf to annoted with",
                    "inputBinding": {
                        "prefix": "--anno_with_vcf"
                    },
                    "id": "#annotate_concat.cwl/anno_with_vcf"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "doc": "Combined Input vcf that gets annotated",
                    "inputBinding": {
                        "prefix": "--combined_vcf"
                    },
                    "id": "#annotate_concat.cwl/combined_vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${return inputs.combined_vcf.basename.replace('.vcf', '_anno.vcf')}"
                    },
                    "id": "#annotate_concat.cwl/annotated_concat_vcf_output_file"
                }
            ],
            "id": "#annotate_concat.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "types": [
                        {
                            "$import": "#variants_tools.yaml/run_tools"
                        },
                        {
                            "$import": "#bcftools.yaml/bcftools_params"
                        }
                    ],
                    "class": "SchemaDefRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/annotate_concat_input_header"
                },
                {
                    "type": "#bcftools.yaml/bcftools_params",
                    "id": "#main/bcftools_params"
                },
                {
                    "type": "string",
                    "id": "#main/normal_sample_name"
                },
                {
                    "type": "#variants_tools.yaml/run_tools",
                    "id": "#main/run_tools"
                },
                {
                    "type": "string",
                    "id": "#main/tumor_sample_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/vcf_mutect"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/vcf_vardict"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/annotate_concat/annotated_concat_vcf_output_file",
                    "id": "#main/annotated_combined_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/concat/concat_vcf_output_file",
                    "id": "#main/combined_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#annotate_concat.cwl",
                    "in": [
                        {
                            "source": "#main/annotate_concat_input_header",
                            "id": "#main/annotate_concat/anno_header"
                        },
                        {
                            "source": "#main/vcf_mutect",
                            "id": "#main/annotate_concat/anno_with_vcf"
                        },
                        {
                            "source": "#main/concat/concat_vcf_output_file",
                            "id": "#main/annotate_concat/combined_vcf"
                        }
                    ],
                    "out": [
                        "#main/annotate_concat/annotated_concat_vcf_output_file"
                    ],
                    "id": "#main/annotate_concat"
                },
                {
                    "run": "#bcftools_concat.cwl",
                    "in": [
                        {
                            "valueFrom": "$(inputs.bcftools_params.allow_overlaps)",
                            "id": "#main/concat/allow_overlaps"
                        },
                        {
                            "valueFrom": "$(inputs.run_tools.bcftools)",
                            "id": "#main/concat/bcftools"
                        },
                        {
                            "source": "#main/bcftools_params",
                            "id": "#main/concat/bcftools_params"
                        },
                        {
                            "source": "#main/normal_sample_name",
                            "id": "#main/concat/normal_sample_name"
                        },
                        {
                            "valueFrom": "$(inputs.tumor_sample_name + '.' + inputs.normal_sample_name + '.combined-variants.vcf')",
                            "id": "#main/concat/output"
                        },
                        {
                            "valueFrom": "$(inputs.bcftools_params.rm_dups)",
                            "id": "#main/concat/rm_dups"
                        },
                        {
                            "source": "#main/run_tools",
                            "id": "#main/concat/run_tools"
                        },
                        {
                            "source": "#main/tumor_sample_name",
                            "id": "#main/concat/tumor_sample_name"
                        },
                        {
                            "source": "#main/create_vcf_file_array/vcf_files",
                            "id": "#main/concat/vcf_files"
                        }
                    ],
                    "out": [
                        "#main/concat/concat_vcf_output_file"
                    ],
                    "id": "#main/concat"
                },
                {
                    "in": [
                        {
                            "source": "#main/vcf_mutect",
                            "id": "#main/create_vcf_file_array/vcf_mutect"
                        },
                        {
                            "source": "#main/vcf_vardict",
                            "id": "#main/create_vcf_file_array/vcf_vardict"
                        }
                    ],
                    "out": [
                        "#main/create_vcf_file_array/vcf_files"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "requirements": [
                            {
                                "class": "InlineJavascriptRequirement"
                            }
                        ],
                        "inputs": [
                            {
                                "type": "File",
                                "secondaryFiles": [
                                    ".tbi"
                                ],
                                "id": "#main/create_vcf_file_array/c93f420d-24a7-445d-893f-0cc5d080fa5b/vcf_mutect"
                            },
                            {
                                "type": "File",
                                "secondaryFiles": [
                                    ".tbi"
                                ],
                                "id": "#main/create_vcf_file_array/c93f420d-24a7-445d-893f-0cc5d080fa5b/vcf_vardict"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "secondaryFiles": [
                                    ".tbi"
                                ],
                                "id": "#main/create_vcf_file_array/c93f420d-24a7-445d-893f-0cc5d080fa5b/vcf_files"
                            }
                        ],
                        "expression": "${ var project_object = {}; project_object['vcf_files'] = [inputs.vcf_vardict, inputs.vcf_mutect]; return project_object; }",
                        "id": "#main/create_vcf_file_array/c93f420d-24a7-445d-893f-0cc5d080fa5b"
                    },
                    "id": "#main/create_vcf_file_array"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
